scala.reflect.reify.phases

# Reify

###
Related Doc: package phases

#### trait Reify extends GenSymbols with GenTypes with GenNames with GenTrees with GenAnnotationInfos with GenPositions with GenUtils

Self Type
  Reifier
Source
  Reify.scala

Linear Supertypes
GenUtils, GenPositions, GenAnnotationInfos, GenTrees, GenNames, GenTypes, GenSymbols, AnyRef, Any
Known Subclasses
ApplyReifier, Phases, Reifier, Reifier, UnapplyReifier
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Reify
2. GenUtils
3. GenPositions
4. GenAnnotationInfos
5. GenTrees
6. GenNames
7. GenTypes
8. GenSymbols
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Type Members

1. #### case class Reification (name: tools.nsc.Global.Name, binding: tools.nsc.Global.Tree, tree: tools.nsc.Global.Tree) extends Product with Serializable

   Definition Classes
     GenSymbols

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Reify to any2stringadd[Reify] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Reify, B)

   Implicit information
     This member is added by an implicit conversion from Reify to ArrowAssoc[Reify] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object TypedOrAnnotated

   Definition Classes
     GenUtils

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8. #### def boundSymbolsInCallstack: List[tools.nsc.Global.Symbol]

9. #### def call(fname: String, args: tools.nsc.Global.Tree*): tools.nsc.Global.Tree

   Definition Classes
     GenUtils

10. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

11. #### def current: Any

12. #### def currents: List[Any]

13. #### def ensuring(cond: (Reify) ⇒ Boolean, msg: ⇒ Any): Reify

    Implicit information
      This member is added by an implicit conversion from Reify to Ensuring[Reify] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: (Reify) ⇒ Boolean): Reify

    Implicit information
      This member is added by an implicit conversion from Reify to Ensuring[Reify] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean, msg: ⇒ Any): Reify

    Implicit information
      This member is added by an implicit conversion from Reify to Ensuring[Reify] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean): Reify

    Implicit information
      This member is added by an implicit conversion from Reify to Ensuring[Reify] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

18. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

19. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

20. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Reify to StringFormat[Reify] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

21. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

22. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

23. #### def isCrossStageTypeBearer(tree: tools.nsc.Global.Tree): Boolean

    Definition Classes
      GenUtils

24. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

25. #### def isSemiConcreteTypeMember(tpe: tools.nsc.Global.Type): Boolean

    Definition Classes
      GenUtils

26. #### def mirrorBuildCall(name: tools.nsc.Global.TermName, args: tools.nsc.Global.Tree*): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

27. #### def mirrorCall(name: tools.nsc.Global.TermName, args: tools.nsc.Global.Tree*): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

28. #### def mirrorFactoryCall(prefix: tools.nsc.Global.TermName, args: tools.nsc.Global.Tree*): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

29. #### def mirrorFactoryCall(value: Product, args: tools.nsc.Global.Tree*): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

30. #### def mirrorMirrorCall(name: tools.nsc.Global.TermName, args: tools.nsc.Global.Tree*): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

31. #### def mirrorMirrorSelect(name: tools.nsc.Global.TermName): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

32. #### def mirrorSelect(name: tools.nsc.Global.TermName): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

33. #### def mirrorSelect(name: String): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

34. #### def mkList(args: List[tools.nsc.Global.Tree]): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

35. #### def mkListMap(args: List[tools.nsc.Global.Tree]): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

36. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

37. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

38. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

39. #### def origin(sym: tools.nsc.Global.Symbol): String

    Definition Classes
      GenUtils

40. #### def path(fullname: String, mkName: (String) ⇒ tools.nsc.Global.Name): tools.nsc.Global.Tree

    An (unreified) path that refers to definition with given fully qualified name

    An (unreified) path that refers to definition with given fully qualified name

    mkName

      Creator for last portion of name (either TermName or TypeName)

    Definition Classes
      GenUtils

41. #### def reificationIsConcrete: Boolean

    Keeps track of whether this reification contains abstract type parameters

    Keeps track of whether this reification contains abstract type parameters

    Definition Classes
      GenTypes

42. #### def reify(reifee: Any): tools.nsc.Global.Tree

    Reifies any supported value.

    Reifies any supported value. For internal use only, use `reified` instead.

43. #### def reifyAnnotationInfo(ann: tools.nsc.Global.AnnotationInfo): tools.nsc.Global.Tree

    Definition Classes
      GenAnnotationInfos

44. #### def reifyBuildCall(name: tools.nsc.Global.TermName, args: Any*): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

45. #### def reifyFlags(flags: tools.nsc.Global.FlagSet): tools.nsc.Global.Tree

    Definition Classes
      GenTrees

46. #### def reifyFreeTerm(binding: tools.nsc.Global.Tree): tools.nsc.Global.Tree

    Definition Classes
      GenSymbols

47. #### def reifyFreeType(binding: tools.nsc.Global.Tree): tools.nsc.Global.Tree

    Definition Classes
      GenSymbols

48. #### def reifyList(xs: List[Any]): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

49. #### def reifyMirrorObject(x: Product): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

50. #### def reifyMirrorObject(name: String): tools.nsc.Global.Tree

    Reify a case object defined in Mirror

    Reify a case object defined in Mirror

    Definition Classes
      GenUtils

51. #### def reifyModifiers(m: tools.nsc.Global.Modifiers): tools.nsc.Global.Tree

    Definition Classes
      GenTrees

52. #### def reifyName(name: tools.nsc.Global.Name): tools.nsc.Global.Tree

    Definition Classes
      GenNames

53. #### def reifyPosition(pos: tools.nsc.Global.Position): tools.nsc.Global.Tree

    Definition Classes
      GenPositions

54. #### def reifyProduct(prefix: String, elements: List[Any]): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

55. #### def reifyProduct(x: Product): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

56. #### def reifySymDef(sym: tools.nsc.Global.Symbol): tools.nsc.Global.Tree

    Definition Classes
      GenSymbols

57. #### def reifySymRef(sym: tools.nsc.Global.Symbol): tools.nsc.Global.Tree

    Reify a reference to a symbol

    Reify a reference to a symbol

    Definition Classes
      GenSymbols

58. #### def reifyTree(tree: tools.nsc.Global.Tree): tools.nsc.Global.Tree

    Reify a tree.

    Reify a tree. For internal use only, use `reified` instead.

    Definition Classes
      GenTrees

59. #### def reifyTreeSymbols: Boolean

    Definition Classes
      GenTrees

60. #### def reifyTreeSyntactically(tree: tools.nsc.Global.Tree): tools.nsc.Global.Tree

    Definition Classes
      GenTrees

61. #### def reifyTreeTypes: Boolean

    Definition Classes
      GenTrees

62. #### def reifyType(tpe: tools.nsc.Global.Type): tools.nsc.Global.Tree

    Reify a type.

    Reify a type. For internal use only, use `reified` instead.

    Definition Classes
      GenTypes

63. #### def scalaFactoryCall(name: String, args: tools.nsc.Global.Tree*): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

64. #### def scalaFactoryCall(name: tools.nsc.Global.TermName, args: tools.nsc.Global.Tree*): tools.nsc.Global.Tree

    Definition Classes
      GenUtils

65. #### def spliceType(tpe: tools.nsc.Global.Type): tools.nsc.Global.Tree

    Definition Classes
      GenTypes

66. #### def symtab: Reifier.SymbolTable

    Symbol table of the reifee.

    Symbol table of the reifee.

    Keeps track of auxiliary symbols that are necessary for this reification session. These include: 1) Free vars (terms, types and existentials), 2) Non-locatable symbols (sometimes, e.g. for RefinedTypes, we need to reify these; to do that we create their copies in the reificode) 3) Non-locatable symbols that are referred by #1, #2 and #3

    Exposes three main methods: 1) `syms` that lists symbols belonging to the table, 2) `symXXX` family of methods that provide information about the symbols in the table, 3) `encode` that renders the table into a list of trees (recursively populating #3 and setting up initialization code for #1, #2 and #3)

    Definition Classes
      GenSymbols

67. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

68. #### def termPath(fullname: String): tools.nsc.Global.Tree

    An (unreified) path that refers to term definition with given fully qualified name

    An (unreified) path that refers to term definition with given fully qualified name

    Definition Classes
      GenUtils

69. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

70. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

71. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

72. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

73. #### def →[B](y: B): (Reify, B)

    Implicit information
      This member is added by an implicit conversion from Reify to ArrowAssoc[Reify] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from GenUtils

### Inherited from GenPositions

### Inherited from GenAnnotationInfos

### Inherited from GenTrees

### Inherited from GenNames

### Inherited from GenTypes

### Inherited from GenSymbols

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Reify to any2stringadd[Reify]

### Inherited by implicit conversion StringFormat from Reify to StringFormat[Reify]

### Inherited by implicit conversion Ensuring from Reify to Ensuring[Reify]

### Inherited by implicit conversion ArrowAssoc from Reify to ArrowAssoc[Reify]

### Ungrouped